/// Josh Unit Test Library

#pragma once
#include <functional>
#include <string>
#include <jlog/jlog.hpp>

namespace jtest {

    // Requirements
    //

    bool check(bool condition) {
        if (!condition)
            throw;
        return condition;
    }

    bool test(const std::string& testname, const std::function<void()>& callback, const std::string& file, int line)
    {
        try {
            callback();
        } catch(...) {
            jlog::log({
                {.colorCode = jlog::ansi_escape_codes::FG_RED, .content = testname},
                {.content = "Failed!"}
            });
            return false;
        }

        jlog::log({
            {.content = std::format("{}:{}", file, line)},
                {.colorCode = jlog::ansi_escape_codes::FG_GREEN, .content = testname},
                {.content = "Passed!", .delimiter = ""}
            });
        return true;
    }

    void run_tests() {

    }

}

#define TEST(a, b) jtest::test(a, b, __FILE__, __LINE__);
